using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace CShare.NET2005
{
    public partial class MainForm : Form
    {
        //Interface definitions.
        //==============================================================================================================
        [DllImport("pcltopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakBegin();

        [DllImport("pcltopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakEnd(int nHandle);

        [DllImport("pcltopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakExport(int nHandle);

        [DllImport("pcltopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakSetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,  
                                                int nValue2,   
                                                string lpValue1,  
                                                string lpValue2);

        [DllImport("pcltopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakGetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,
                                                int nValue2,
                                                string lpValue1,
                                                string lpValue2);


        //Definitions of oakSetOption's nIndex properties 
        //==============================================================================================================
        const int OAK_Set_Output	=2101;
        const int OAK_Set_Input		=2102;
        const int OAK_Set_DPI		=2103;
        const int OAK_Set_PDFInfo	=2105;
        const int OAK_Set_PDFEncrypt=2106;

        //Supported pdf information
        const string OAK_PDFInfo_TITLE      ="title";
        const string OAK_PDFInfo_SUBJECT    = "subject";
        const string OAK_PDFInfo_AUTHOR     = "author";
        const string OAK_PDFInfo_KEYWORDS   = "keywords";
        const string OAK_PDFInfo_APPLICATION= "creator";

        //Supported the length of pdf encrypt
        const int OAK_PDF_ENCRYPT_LEVEL_40   =40;
        const int OAK_PDF_ENCRYPT_LEVEL_128  =128;

        //Supported operation limited
        const int OAK_PDF_PERMISSION_NONE     =0;
        const int OAK_PDF_PERMISSION_PRINT    =1;
        const int OAK_PDF_PERMISSION_COPYING  =2;
        const int OAK_PDF_PERMISSION_MODIFY   =4;
        const int OAK_PDF_PERMISSION_ALL      =7;

        const int TRUE = 1;
        const int FALSE = 0;
        //==============================================================================================================

        public MainForm()
        {
            InitializeComponent();
        }

        //==============================================================================================================
        private void btnDemo1_Click(object sender, EventArgs e)
        {
            int id;
            int xdpi=300, ydpi=300;
            string sOutFname;
            string sUserPw = "user", sOwnerPw = "owner";

            id = oakBegin();
            if( id != 0 ){

                //=============================================================
                //set output file
                sOutFname = "output.pdf";
                oakSetOption(id, OAK_Set_Output, 0, 0, sOutFname, null);


                //set image DPI ,default xdpi=150,ydpi=150
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, "","");

                //set pdf info
                oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "title");
                oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "subject");
                oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_AUTHOR, "author");
                oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_KEYWORDS, "keywords");
                oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "creator");

                //set pdf security
                oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, null, sOwnerPw);
                //oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

                //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", null);
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", null);

                //strat convert
                oakExport(id);


	            oakEnd(id);
                MessageBox.Show("Conversion successful");
           }

        }


        private void MainForm_Load(object sender, EventArgs e)
        {

        }


    }
}