unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

const
//Definitions of oakSetOption's nIndex properties 
//==============================================================================================================
 OAK_Set_Output		=2101;
 OAK_Set_Input		=2102;
 OAK_Set_DPI			=2103;
 OAK_Set_PDFInfo		=2105;
 OAK_Set_PDFEncrypt	=2106;

//Supported pdf information
 OAK_PDFInfo_TITLE          ='title';
 OAK_PDFInfo_SUBJECT        ='subject';
 OAK_PDFINfo_AUTHOR         ='author';
 OAK_PDFINfo_KEYWORDS       ='keywords';
 OAK_PDFInfo_APPLICATION    ='creator';

//Supported the length of pdf encrypt
 OAK_PDF_ENCRYPT_LEVEL_40   =40;
 OAK_PDF_ENCRYPT_LEVEL_128  =128;

//Supported operation limited
 OAK_PDF_PERMISSION_NONE     =0;
 OAK_PDF_PERMISSION_PRINT    =1;
 OAK_PDF_PERMISSION_COPYING  =2;
 OAK_PDF_PERMISSION_MODIFY   =4;
 OAK_PDF_PERMISSION_ALL      =7;


type

  //interface definitions.
  //==========================================================================================
    _oakBegin = function():Longint; stdcall;
    _oakEnd = function(nHandle:Longint):Longint; stdcall;
    _oakExport = function(nHandle:Longint):Longint; stdcall;
    _oakSetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;
    _oakGetOption = function( nHandle:Longint; //Conversion object's handle.
                          nIndex:Longint;  //Property tag,refer to the following property definitions.
                          nValue1:Longint;
                          nValue2:Longint;
                          pValue1:PChar;
                          pValue2:PChar):Longint; stdcall;

  //==========================================================================================




  TMainForm = class(TForm)
    btnDemo1: TButton;
    m_ProgressBar: TProgressBar;
    procedure btnDemo1Click(Sender: TObject);
  private
    { Private declarations }


    //---------------------------------------------------------------------------
    m_hDll: HMODULE;
    oakBegin: _oakBegin;
    oakEnd: _oakEnd;
    oakExport: _oakExport;
    oakSetOption: _oakSetOption;
    oakGetOption: _oakGetOption;

    function LoadDLL():BOOL;
    function FreeDLL():BOOL;  
    //----------------------------------------------------------------------------

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

//==========================================================================================
function TMainForm.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := 'pcltopdf.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, '_oakBegin@0');
	 if pFunc = nil then goto ERR_FLAG;
   oakBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakEnd@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakExport@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakExport := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakSetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakSetOption := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_oakGetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakGetOption := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;


//==========================================================================================

function TMainForm.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;


//==========================================================================================

procedure TMainForm.btnDemo1Click(Sender: TObject);
var
    sOutFname: PAnsiChar;
    sUserPw,sOwnerPw: PAnsiChar;
    id: Longint;
    xdpi,ydpi:Longint;


begin

  xdpi:=300;
  ydpi:=300;
  sUserPw:='user';
  sOwnerPw:='owner';


	if LoadDLL() = TRUE then

  begin
    id := oakBegin();
		if id <> 0 then
    begin

			//=============================================================
			//set output file
			oakSetOption(id, OAK_Set_Output, 0, 0, 'output.pdf', nil);

			//set image DPI ,default xdpi=150,ydpi=150
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, nil, nil);

			//set pdf info
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, 'title');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, 'subject');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, 'author');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, 'keywords');
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, 'creator');
	
			//set pdf security
			oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, nil, sOwnerPw);
			//oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\pcl_files\\test1.pcl', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\pcl_files\\test2.pcl', nil);
			oakSetOption(id, OAK_Set_Input, 0, 0, '.\\pcl_files\\test3.pcl', nil);

			
			//strat convert
			oakExport(id);

			oakEnd(id);
		end;
		FreeDLL();
    ShowMessage('Conversion successful!');
  end
	else
		ShowMessage('Loading dll failure!');



end;



//==========================================================================================


end.
