Public Class MainForm

    'interface definitions.
    Private Declare Function oakBegin Lib "pcltopdf.dll" Alias "_oakBegin@0" () As Integer
    Private Declare Sub oakEnd Lib "pcltopdf.dll" Alias "_oakEnd@4" (ByVal id As Integer)
    Private Declare Function oakExport Lib "pcltopdf.dll" Alias "_oakExport@4" (ByVal id As Integer) As Integer
    Private Declare Function oakSetOption Lib "pcltopdf.dll" Alias "_oakSetOption@24" (ByVal id As Integer, ByVal code As Integer, ByVal nPara1 As Integer, ByVal nPara2 As Integer, ByVal sPara1 As String, ByVal sPara2 As String) As Integer
    Private Declare Function oakGetOption Lib "pcltopdf.dll" Alias "_oakGetOption@24" (ByVal id As Integer, ByVal code As Integer, ByVal nPara1 As Integer, ByVal nPara2 As Integer, ByVal sPara1 As String, ByVal sPara2 As String) As Integer

    'Definitions of oakSetOption's nIndex properties 
    '======================================================================================================
    Const OAK_Set_Output = 2101
    Const OAK_Set_Input = 2102
    Const OAK_Set_DPI = 2103
    Const OAK_Set_PDFInfo = 2105
    Const OAK_Set_PDFEncrypt = 2106

    'Supported pdf information
    Const OAK_PDFInfo_TITLE = "title"
    Const OAK_PDFInfo_SUBJECT = "subject"
    Const OAK_PDFINfo_AUTHOR = "author"
    Const OAK_PDFINfo_KEYWORDS = "keywords"
    Const OAK_PDFInfo_APPLICATION = "creator"

    'Supported the length of pdf encrypt
    Const OAK_PDF_ENCRYPT_LEVEL_40 = 40
    Const OAK_PDF_ENCRYPT_LEVEL_128 = 128

    'Supported operation limited
    Const OAK_PDF_PERMISSION_NONE = 0
    Const OAK_PDF_PERMISSION_PRINT = 1
    Const OAK_PDF_PERMISSION_COPYING = 2
    Const OAK_PDF_PERMISSION_MODIFY = 4
    Const OAK_PDF_PERMISSION_ALL = 7

    '==============================================================================================================


    Private Sub btnDemo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDemo1.Click
        Dim id As Integer
        Dim sOutFname As String
        Dim sUserPw = "user"
        Dim sOwnerPw = "owner"
        Dim xdpi = 300
        Dim ydpi = 300

        id = oakBegin()
        If id <> 0 Then

            '=============================================================
            'set output file
            sOutFname = "output.pdf"
            oakSetOption(id, OAK_Set_Output, 0, 0, sOutFname, Nothing)

            'set image DPI ,default xdpi=150,ydpi=150
            oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, Nothing, Nothing)

            'set pdf info
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "title")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "subject")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, "author")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, "keywords")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "creator")

            'set pdf security
            oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, Nothing, sOwnerPw)
            'oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

            'set input file
            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", Nothing)
            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", Nothing)
            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", Nothing)


            'strat Convert
            oakExport(id)

            oakEnd(id)
        End If
    End Sub





    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
